package atomes;

import classement.EnsembleTrie;
import espace3D.Vecteur3D;
import photons.Dispositif_Laser;

/**
 * classe drive de la classe action,
 * implante une dsexcitation spontane
 */
public class Desexspt extends Action {
	Dispositif_Laser laser;
    double frequence;
    Vecteur3D direction;
    /**
     * constructeur d'une action de desexcitation spontane
     * @param atome // atome concern
     */
    public Desexspt(Atome atome,Dispositif_Laser laser){
        super(atome,0);
        this.laser = laser;
        this.frequence = 0;
        this.direction = null;
    }
    /**
     * mise  jour de l'action
     * (date frquence et direction)
     */
    public void set(double date, double frequence, Vecteur3D direction){
	    this.valeur = date;
	    this.frequence = frequence;
	    this.direction = direction;
    }
    /**
     * excution d'une desxecitation spontane
     * et calcul de la prochaine excitation
     */
    public Action execute() {
        atome.desexspt(valeur, -frequence, direction,0);
        return atome.prochaineexcitation(laser);
    }
    /**
     * incrmentation du compteur de desxcitations spontanes
     */
    public void incremente(int[]compteurs){
    	compteurs[2]= compteurs[2]+1;
    }
}
