package classement;
/**
 * classe gnrique reprsentant un ensemble d'lements tris
 */
public class EnsembleTrie {
	public static Element max = new Element(Double.MAX_VALUE);
	private int nbelements;
	//--------
	//Noeud portant l'lement ultime, racine de l'arbre binaire des lments
    Noeud tete;
    public Noeud get_tete(){return tete;}
    
    //Constructeur
    public EnsembleTrie(){
    	tete = new Noeud(max,null,null,0);
    }
    //insertion d'un lement
    public void insertion(Element ev){
    	tete.insertion(ev);
    	nbelements = nbelements+1;
    	return;
    }
    //extraction du prochain lement et calcul 
    //du nouveau candidat  la premire place
    public Element prochaine(){
    	Noeud first = tete.get_first();
    	Element prochain = first.get_element();
    	first.depilement();
    	return prochain;
    }
    public double valeur_max(){
    	Noeud gauche = tete.get_gauche();
    	Noeud droit = tete.get_droit();
    	if(droit!=null){return droit.get_t();}
    	if(gauche!=null){return gauche.get_t();}
    	return tete.get_t();
    }
    public double valeur_min(){
    	Noeud first = tete.get_first();
    	return first.get_t();
    }
    public double valeur_med(){
    	Noeud next = null;
    	Parcours parcours = new Parcours(this);
    	int med = (int) Math.ceil(nbelements/2);
    	for( int i =0; i<=med; i++){
    		next = parcours.next();
    	}
    	return next.get_t();
    }
}
