package photons;

import espace3D.Vecteur3D;

/**
 * classe d'objets conservant les donnes d'un photon
 * objets temporaires de transferts de donnes entre
 * les calculs du dispositifs laser et ceux de l'atome
 */
public class Photon {
    //-----
    private double frequence ;public double get_frequence(){return frequence;}
    //frquence du photon;
    private Vecteur3D direction;public Vecteur3D get_dir(){return direction;}
    //direction du photon
    private double delai;
    public double get_delai(){return delai;}
    public void setdelai(double delai){this.delai = delai;}
    // dlai d'interaction avec l'atome
    //-----------------------
    public Photon(double frequence, Vecteur3D direction,double delai){
        this.frequence = frequence;
        this.direction = direction;
        this.delai = delai;	
    }
}
