package classement;

/**
 *Itrateur, permettant de parcourir dans l'ordre un ensemble tri
 */
public class Parcours {
    Noeud dernier_sorti;
    Noeud tete;
	
    public Parcours(EnsembleTrie ens){
        dernier_sorti = null;
        tete = ens.get_tete();
    }
	/**
	 *test de l'existence d'un noeud suivant d'un ensemble tri
	 */
    public boolean hasNext(){
	    if(dernier_sorti == null){return true;}
        if(dernier_sorti.get_ascend()!=null){return true;}
        return false;
    }
	/**
	 *obtention du noeud suivant d'un ensemble tri
	 */
    public Noeud next(){
        if(dernier_sorti == null){
            dernier_sorti = tete.get_first();	
        }else{
            Noeud frere = dernier_sorti.get_frere();
            Noeud ascendant = dernier_sorti.get_ascend();
            if ((frere !=null) && (frere !=dernier_sorti)) {
                dernier_sorti = frere.get_first();
            }else{
                dernier_sorti = ascendant;
            }
        }
        return dernier_sorti;
	}
}
