package fonctions;

public class Gauss extends Fonction1D {
    private double moyenne;
    private double sigma;
    private GaussReduite prototype;

    public Gauss(double moyenne, double sigma){
        this.domaine = new DroiteReelle();
        this.moyenne = moyenne;
        this.sigma = sigma;
        prototype = new GaussReduite();
    }
    public double valeur(double x) {
        double z = (x-moyenne)/sigma;
        return prototype.valeur(z)/sigma;
    }
}
