package fonctions;

public class GaussReduite extends Fonction1D {

    public GaussReduite(){
        domaine = new DroiteReelle();
    }
    public double valeur(double x) {
        double exposant = -x*x/2;
        double coeff = Math.sqrt(2*Math.PI);
        return (1.0/coeff)*Math.exp(exposant);	
	}
}
